#!/usr/bin/perl
# Perl Location one your server

#########################################################
#        Get HTML      	   create 2000.8.31		#
#        Simple Proxy 0.5  modified 2001.5.19		#
#         ΢Ц   http://perl.yesky.net		#
#        Ȩ   http://www.skybamboo.com/perl/	#
#########################################################

#$|=1;

use vars qw( %config );
%config = (	MaxLength	=> 500*1024,	# fetch file max 500K
		RequestTimeOut	=> 30,		# set timeout to 30s
		
		);

my $buffer;
$ENV{'CONTENT_LENGTH'} = 250*1024 if ($ENV{'CONTENT_LENGTH'} >= 250*1024 );	# max 250K input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

use strict;
use LWP::UserAgent;
use HTTP::Request;
use CGI;

# $selfurlԶж    ⣬ֵֶ
my $selfurl;
if ($ENV{SCRIPT_URI}) {	# for cgiwarp
	$selfurl = $ENV{SCRIPT_URI};
	$selfurl =~ s/.cgi\/.*/.cgi/;
}else{
	$selfurl = "http://$ENV{SERVER_NAME}$ENV{SCRIPT_NAME}";
}

my $string = $ENV{PATH_INFO};
$string = substr($string, 1);
&show_help if ($string eq '');

my $askdomain = $string;
$askdomain =~ s/\/.*//;

my $method = $ENV{REQUEST_METHOD};
my $askurl;
if($ENV{'QUERY_STRING'}){
	$askurl = $string."?$ENV{'QUERY_STRING'}";
}else{
	$askurl = $string;
}

&show_help if ( $askurl eq '' );
$askurl = "http://$askurl";

# ###############################################################
# prepare the agent
my $Request = new HTTP::Request ($method => $askurl);
$Request->header(Accept => $ENV{HTTP_ACCEPT});
if(lc($method) eq "post"){
	$Request->content_type($ENV{CONTENT_TYPE});
	$Request->content($buffer);
}

my $UserAgent = new LWP::UserAgent;
$UserAgent->agent( $ENV{HTTP_USER_AGENT} );
$UserAgent->timeout( $config{RequestTimeOut} );
$UserAgent->max_size( $config{MaxLength} );

# ###############################################################
# fetch file
my $content_type = 0;
my $Data_to_next = '';
my $Response = $UserAgent->request($Request, \&callback );
sub callback {
	my($Data, $Response) = @_;
	if (not $content_type) {
		$content_type = $Response->content_type;
		if ($Response->content_length > $config{MaxLength}){
			&show_help("Your desired file is larger than 500K and will be refused by this cgi!");
		}
		print "Content-Type: $content_type\n\n";
	}
	if ($content_type eq 'text/html') {
		my $Data_new;
		$Data = $Data_to_next.$Data;
		while($Data =~ /<(a|link|base|img|form) [^>]*?(href|src|action).*?>/i){
			# only for debug
			# print "$&\n";
			# print &change_url($1, $2, $&)."\n";
			$Data_new .= $`.&change_url($1, $2, $&);
			$Data = $';
		}
		$Data_to_next = $Data;
		print $Data_new;
	}else{
		print $Data;
	}
}
print $Data_to_next;
# check the outcome
if(not $Response->is_success) {
	&show_help("Error: " . $Response->code . " " . $Response->message);
}
exit;

# ###############################################################
# change url
sub change_url {
	my ($tag, $attr, $code) = @_;
	$code =~ /$attr\s*?=\s*?([^ >]*)/i;
	my $url =  $1;
	my ($prefix, $suffix);
	$prefix = $& if ($url =~ /^["']/);
	$suffix = $& if ($url =~ /["']$/);
	$url =~ s/^["']|["']$//g;
	if($url =~ /^\//){
		$code =~ s/$attr\s*?=\s*?([^ >]*)/$attr=$prefix$selfurl\/$askdomain$url$suffix/i;
	}elsif($url =~ /^http:\/\//i) {
		s/.*?:\/\//$selfurl\//i;
		$code =~ s/$attr\s*?=\s*?([^ >]*)/$attr=$prefix$url$suffix/i;
	}
	return $code;
}

# ###############################################################
# show help
sub show_help {
	my ($message)=@_;
	print "Content-Type: text/plain\n\n";
	print "\n\n\n\n";
	print "$message\n" if($message);
	print "Usage: $selfurl/www.yahoo.com/\n\n";
	print "÷$selfurl/www.yahoo.com/\n\n";
	print "    ļСܳ".int($config{MaxLength}/1024)."K\n";
	exit;
}

__END__